// restart Thunderbird
var restartObject = {
   restartMozilla: function(){
        var appStartup = Components.interfaces.nsIAppStartup;
        Components.classes["@mozilla.org/toolkit/app-startup;1"]
          .getService(appStartup).quit(appStartup.eRestart | appStartup.eAttemptQuit);
    }
}

var confirmObject = { 
	confirmNow: function(){	
		var stringsBundle = document.getElementById("string-bundle");
		var st1 = stringsBundle.getString("restart");
		if (confirm(st1)) {
		restartObject.restartMozilla();
		}
	}
}

var restartMozillaObject = { 
	restartNow: function(event){	
		if(event.button == 0) {
		confirmObject.confirmNow();
		}
		else if(event.button == 1) {
		restartObject.restartMozilla();
		}
	}
}

// Toggel Html

var htmlMozillaObject = { 
	htmlOff: function(event){	
		if(event.button == 0) {
		MsgBodyAsPlaintext(); document.getElementById("html").setAttribute("html", "off");
		}
		else if(event.button == 1) {
		MsgBodySanitized(); document.getElementById("html").setAttribute("html", "sanitized");
		}
		else if(event.button == 2) {
		MsgBodyAllowHTML(); document.getElementById("html").setAttribute("html", "on");
		}
	}
}

function htmlButtonIconSet(){

	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefBranch);
	var prefNumber = prefs.getIntPref("mailnews.display.html_as");

	if (prefNumber == 0) {document.getElementById("html").setAttribute("html", "on");}
	else if (prefNumber == 1) {document.getElementById("html").setAttribute("html", "off");}
	else if (prefNumber == 3) {document.getElementById("html").setAttribute("html", "sanitized");}
}

//Delete Mail Marked as Junk
function DeleteJunkMessages() {
	var folderTree = GetFolderTree();
	if (folderTree) {
		var selectedFolders = GetSelectedMsgFolders();
		var selectedFolder = selectedFolders[0];

		// Save old selections
		var currentFolder = GetThreadPaneFolder();
		var currentMessages = GetSelectedMessages();

		// Select folder if not current
		if (selectedFolder != currentFolder) {
			ClearThreadPane();
			ClearMessagePane();
			folderTree.view.selection.clearSelection();
			SelectFolder(selectedFolder.URI);
		}

		var enabled = new Object();
		enabled.value = false;
		var checkStatus = new Object();
		if (gDBView)
			gDBView.getCommandStatus(nsMsgViewCommandType.deleteJunk, enabled, checkStatus);

		// Run command if valid
		if (enabled.value) {
			var djBypassTrash = 0;
			
			try { djBypassTrash = djPrefs.getIntPref("deletejunk.bypasstrash"); } catch (ex) {}
			if (!djBypassTrash || (djBypassTrash == 1 && !djIsJunkFolder)) {
				// Delete junk into Trash
				deleteJunkInFolder();
			} else {
				// Delete junk bypassing Trash
				/* Copied from deleteJunkInFolder() in mailCommands.js
				   Changed if statements so we don't return out of function
				*/
				MsgJunkMailInfo(true);
				var view = GetDBView();

				// need to expand all threads, so we find everything
				view.doCommand(nsMsgViewCommandType.expandAll);

				var treeView = view.QueryInterface(Components.interfaces.nsITreeView);
				var count = treeView.rowCount;
				if (count) {
					var treeSelection = treeView.selection;

					var clearedSelection = false;

					// select the junk messages
					for (var i = 0; i < count; i++) {
						var messageUri = view.getURIForViewIndex(i);
						var msgHdr = messenger.messageServiceFromURI(messageUri).messageURIToMsgHdr(messageUri);
						var junkScore = msgHdr.getStringProperty("junkscore"); 
						var isJunk = ((junkScore != "") && (junkScore != "0"));
						// if the message is junk, select it.
						if (isJunk) {
						  // only do this once
						  if (!clearedSelection) {
							// clear the current selection
							// since we will be deleting all selected messages
							treeSelection.clearSelection();
							clearedSelection = true;
							treeSelection.selectEventsSuppressed = true;
						  }
						  treeSelection.rangedSelect(i, i, true /* augment */);
						}
					}

					// if we didn't clear the selection
					// there was no junk, so bail.
					if (clearedSelection) {
						treeSelection.selectEventsSuppressed = false;
						// delete the selected messages
						//
						// XXX todo
						// should we try to set next message after delete 
						// to the message selected before we did all this, if it was not junk?
                        view.doCommand(nsMsgViewCommandType.deleteNoTrash);
                        ClearMessageSelection();
					}
				}
			}

			/* Commenting out 'compact folder' because it's dangerous!
			   Several times, all mails in my trash that were marked as junk lost their junk status

			if (djPrefs.getBoolPref("deletejunk.compactfolder")) {
				try {
					messenger.CompactFolder(GetFolderDatasource(), selectedFolder.QueryInterface(Components.interfaces.nsIRDFResource), false);
				} catch (ex) {}
			}
			*/
		}

		// Restore selections
		if (selectedFolder != currentFolder && djPrefs.getBoolPref("deletejunk.restoreselection")) {
			try {
				ClearThreadPaneSelection();
				ClearMessagePane();
                ClearThreadPane();

				SelectFolder(currentFolder.URI);

				ClearThreadPaneSelection();
				ClearMessagePane();
			} catch (ex) {}
		}
	}
}


// Send Mail With Out saveing a copy.
function SendWithNoSave(){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefBranch);
	var prevIdentity = gCurrentIdentity;
	var prefstring = "mail.identity." + prevIdentity.key + ".fcc";
	prefs.setBoolPref(prefstring, false);
	goDoCommand('cmd_sendButton');
	prefs.setBoolPref(prefstring, true);
}

//Get the real next Message.

function bRealNavigate(event, dirPrev, srcMain) {
	if(dirPrev) {
		if(srcMain) {
			if (event && event.shiftKey) {
				return MsgPreviousUnreadMessage();
			} else {
				return GoNextMessage(nsMsgNavigationType.previousMessage, false );
			}
		} else {
			if (event && event.shiftKey) {
				return performNavigation(nsMsgNavigationType.previousUnreadMessage);
			} else {
				return LoadMessageByNavigationType(nsMsgNavigationType.previousMessage);
			}
		}
	} else {
		if(srcMain) {
			if (event && event.shiftKey) {
				return MsgNextUnreadMessage();
			} else {
				return GoNextMessage(nsMsgNavigationType.nextMessage, false );
			}
		} else {
			if (event && event.shiftKey) {
				return performNavigation(nsMsgNavigationType.nextUnreadMessage);
			} else {
				return LoadMessageByNavigationType(nsMsgNavigationType.nextMessage);
			}
		}
	}
}

function realNextMessage(event) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefBranch);
	if(prefs.getBoolPref("tbutton.next", false)) {
		bRealNavigate(event, true, true);
	} else {
		bRealNavigate(event, false, true);
	}
}

function realPreviousMessage(event) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefBranch);
	if(prefs.getBoolPref("tbutton.previous", false)) {
		bRealNavigate(event, false, true);
	} else {
		bRealNavigate(event, true, true);
	}
}


function realNextMessageWindow(event) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefBranch);
	if(prefs.getBoolPref("tbutton.next", false)) {
    bRealNavigate(event, true, false);
	} else {
    bRealNavigate(event, false, false);
	}
  if(prefs.getBoolPref("tbutton.next", false) && window.opener && window.opener.GetDBView) {
    bSelectMessageFromOpener();
  }
  if(oldMessageURI == gCurrentMessageUri && prefs.getBoolPref("tbutton.next", false)) {
    if(prefs.getBoolPref("tbutton.next", false) && window.opener) {
      window.opener.focus();
    }
    window.close();
  }
}

function realPreviousMessageWindow(event) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefBranch);
	if(prefs.getBoolPref("tbutton.previous", false)) {
    bRealNavigate(event, false, false);
	} else {
    bRealNavigate(event, true, false);
	}
  if(prefs.getBoolPref("tbutton.previous", false) && window.opener && window.opener.GetDBView) {
    bSelectMessageFromOpener();
  }
  if(oldMessageURI == gCurrentMessageUri && prefs.getBoolPref("tbutton.previous", false)) {
    if(prefs.getBoolPref("tbutton.previous", false) && window.opener) {
      window.opener.focus();
    }
    window.close();
  }
}